@echo off
SET TP=%~dp0
SET TP=%TP:~0,-1%
cd /d "%TP%"
color 2f
chcp 437
mode con lines=40 cols=100
set title=                          Windows Vista/2008/7/2008 R2 Fast Installer (by fujianabc)
set updatetime=   =========================== 2011.08.06 (modfied by steve6375) ========================


REM --------------------------------------------------------------------------------------
REM checking necessary files
REM --------------------------------------------------------------------------------------

REM Are we running on x86 or 64 bit OS
if "%PROGRAMFiles(x86)%"=="" SET CPU=x86
if NOT "%PROGRAMFiles(x86)%"=="" SET CPU=amd64
@echo %CPU% OS detected

if not exist imagex.exe if not exist %SystemRoot%\system32\imagex.exe (
if exist "%ProgramFiles%\Windows AIK\Tools\%CPU%\imagex.exe" copy "%ProgramFiles%\Windows AIK\Tools\%CPU%\imagex.exe" "%TP%"
)

if not exist bcdboot.exe if not exist %SystemRoot%\system32\bcdboot.exe (
if exist "%ProgramFiles%\Windows AIK\Tools\%CPU%\bcdboot.exe" copy "%ProgramFiles%\Windows AIK\Tools\%CPU%\bcdboot.exe" "%TP%"
)
if not exist bootsect.exe if not exist %SystemRoot%\system32\bootsect.exe (
if exist "%ProgramFiles%\Windows AIK\Tools\PETools\%CPU%\bootsect.exe" copy "%ProgramFiles%\Windows AIK\Tools\PETools\%CPU%\bootsect.exe" "%TP%"
)

REM check to see if we have all files...
for %%i in (imagex bcdboot bootsect reg) do (
if not exist %%i.exe if not exist %SystemRoot%\system32\%%i.exe (
echo %%i.exe is missing. Setup can't continue. 
echo Please install Microsoft WAIK for Windows 7 and try again.
goto fail
)
)


REM --------------------------------------------------------------------------------------
REM start
REM --------------------------------------------------------------------------------------
:start
cls
echo.
echo %title%
echo.                   
echo %updatetime%
echo.
echo    This installer copies the files from your Windows Vista/2008/7/2008R2 x86/x64 install DVD
echo    to another disk attached to this system, and then sets that hard disk up to boot to Windows.
echo.   
echo    Using this installer script you can quickly install Windows
echo    to any other hard disk (even a USB disk).
echo.
echo    If your target disk has two paritions, you can have one partition as the BOOT partition
echo    and the other as the SYSTEM partition (to hold the Windows files).
echo    If you only have one partition on the target hard drive, the BOOT and SYSTEM partition
echo    will be the same so enter the same drive letter when asked.
echo.
echo    Before any changes are made, you will be shown a final summary screen.
echo    To exit now, close this window.
echo.

SET Choice=
SET /P Choice=     Press Enter to continue (H=Help) : 
IF /I "%Choice%" == "H" (
cls
type readme.txt
echo    Press any key to continue ...
pause>nul
goto :start
)
echo.
echo.
echo.


REM --------------------------------------------------------------------------------------
REM select install.wim
REM --------------------------------------------------------------------------------------

echo    SELECT WINDOWS SOURCE FILE
echo    ==========================
echo.
echo    Please select the large Windows sources\install.wim source file.
echo    It is usually in the "Sources" directory of your Windows DVD.
echo    If you have a Windows ISO file and not a DVD, you will need to mount it first 
echo    using Virtual Clone Disk or a similar ISO mounting utility.
echo.
echo    Press a key to select the Install.wim file...
echo.
pause> nul
start /wait wincmd load %TP%\getWim.ini
cd /d "%TP%"
call setWimpath.cmd
del setWimpath.cmd
IF '%Wimpath%'=='' goto fail
if not exist %Wimpath% (
echo.
echo    No wim file is selected.
goto fail
)
REM Get the path of the directory which contains install.wim 
for /f "delims=" %%a in (%Wimpath%) do set wimdir=%%~dpa
set wimdir=%wimdir:~0,-1%



REM --------------------------------------------------------------------------------------
REM show the contents of the selected wim file
REM --------------------------------------------------------------------------------------
cd /d "%TP%"
SET Wimindex=
cls
echo.
echo %title%
echo.                   
echo %updatetime%
echo.
echo    Path of your Wim file: %Wimpath%
echo.
imagex /info %Wimpath% >wiminfo.txt


for /f "tokens=1,2 delims=:" %%i in (wiminfo.txt) do IF /I "%%i"=="Image Count" echo Total image number:%%j
echo.
echo Available image:
echo.
for /f "tokens=2,3 delims=<>=" %%i in (wiminfo.txt) do (
IF /I "%%i"=="IMAGE INDEX" set/p=%%j<nul
IF /I "%%i"=="NAME" echo . %%j
)
echo.

REM --------------------------------------------------------------------------------------
REM select the image number of the wim file
REM --------------------------------------------------------------------------------------
:indexnumber
SET Choice=
SET /P Choice=   Please input the index number [1-99] : 
IF "%Choice%"=="" (
goto indexnumber
) else (
SET Choice=%Choice:~0,3%
)
IF "%Choice%"=="" goto indexnumber
SET errorindex=YES
for /f "tokens=2,3 delims=<>=" %%i in (wiminfo.txt) do IF /I "%%i"=="IMAGE INDEX" IF /I "%%j"==""%Choice%"" SET errorindex=NO
IF '%errorindex%'=='YES' (
echo    The index number is wrong, please input a correct number.
goto indexnumber
)
SET Wimindex=%Choice%
del wiminfo.txt >nul

REM Set language. Set the tag for vista/2008, in order to fix the system drive letter in the registry of Vista/2008.
set isvista=0
set lang=en-US
for /f "tokens=2,3 delims=<>=" %%i in ('imagex /info %Wimpath% %Choice%') do (
IF /I "%%i"=="LANGUAGE" set lang=%%j
IF /I "%%i"=="MAJOR" IF /I "%%j" NEQ "6" goto osdrive
IF /I "%%i"=="MINOR" IF /I "%%j"=="0" SET isvista=1
)


REM --------------------------------------------------------------------------------------
REM select system partition
REM --------------------------------------------------------------------------------------
:osdrive
cd /d "%TP%"
SET installpath=
cls
echo.
echo %title%
echo.                   
echo %updatetime%
echo.
echo    Path of your Wim file: %Wimpath%
echo    The index number: %Wimindex%
echo.
echo.
echo    TARGET DRIVE LETTER
echo    ===================
echo    Please enter the drive letter of the partition
echo    that you want to copy the Windows files onto:
echo.
SET Choice=
SET /P Choice=   Please enter the TARGET SYSTEM DRIVE letter (e.g. F) : 
echo.
IF "%Choice%"=="" goto osdrive
SET Choice=%Choice:~0,1%:
vol %Choice%>nul 2>nul || (
echo    The partition %Choice% does not exist, please input again.
echo    Press any key to continue...
pause>nul
goto osdrive
)
echo Testing if the partition is writable >%Choice%\test.tst
if not exist %Choice%\test.tst (
echo    Partition %Choice% is not writable, please input again.
echo    Press any key to continue...
pause>nul
goto osdrive
)
del %Choice%\test.tst>nul 2>nul
if exist %Choice%\test.tst (
echo    Partition %Choice% is not writable, please input again.
echo    Press any key to continue...
pause>nul
goto osdrive
)


if "%Choice%"=="%SystemDrive%" (
echo	WARNING: Target drive letter is same as this systems Windows drive letter!
echo	This will overwrite files on your %SystemDrive% drive!
SET /P SURE=Do you really want to continue?
if /I NOT "%SURE%"=="Y" goto osdrive
)

SET installpath=%Choice%


REM --------------------------------------------------------------------------------------
REM Verify if the partition is NTFS
REM --------------------------------------------------------------------------------------
md %installpath%\$mft >NUL
if not errorlevel 1 (
rd %installpath%\$mft >NUL
echo.
echo    %installpath% is not NTFS
echo    Please mannually convert or format this partition to NTFS first.
echo.
goto fail
)
cls

REM --------------------------------------------------------------------------------------
REM Verify the free size of the partition
REM --------------------------------------------------------------------------------------
set drvsize=
md %installpath%\$$$ >NUL
for /f "tokens=3" %%i in ('dir /-c %installpath%\') do set drvsize=%%i
rd %installpath%\$$$ >NUL
if %drvsize% LSS 1000000000 goto not_enough
set drvsize=%drvsize:~0,-9%
if %drvsize% LSS 10 (
goto not_enough
) else (
goto enough
)

:not_enough
echo. 
echo    The free size of %installpath% is less than 10GB, error may happen if you continue to install.   
echo. 
SET Choice=
SET /P Choice=    Input C to continue, or input others to select other partition:
IF /I not "%Choice%"=="C" (
goto osdrive
) else (
goto enough
)


REM --------------------------------------------------------------------------------------
REM Processing format
REM --------------------------------------------------------------------------------------
:enough
IF exist %installpath%\windows (
echo.
echo    INFORMATION: %installpath% already contains another windows, NOW FORMATTING %installpath%.
echo.
) else (
goto bootdrive
)

:format_hd
format /? >nul 2>nul
if errorlevel 1 (
echo    The command "format" is missing in your current OS, installation process cannot continue. 
echo    Please format %installpath% by yourself, and then rerun this installer.   
goto fail
)
@echo FORMATTING %installpath%
@echo.
@echo FILES on drive %installpath%
dir /b %installpath%
echo.
echo VOLUME DETAILS of %installpath%
vol %installpath%
echo.
format /FS:NTFS /q /x %installpath%


REM --------------------------------------------------------------------------------------
REM select the boot partition
REM --------------------------------------------------------------------------------------
:bootdrive
cd /d "%TP%"
SET bootpath=
cls
echo.
echo %title%
echo.                   
echo %updatetime%
echo.
echo    Path of your Wim file: %Wimpath%
echo    The index number: %Wimindex%
echo    Drive letter for OS partition: %installpath%
echo.
echo.
echo    TARGET BOOTDRIVE LETTER
echo    =======================
echo    Please enter the drive letter of the volume that you want to be the ACTIVE primary partition
echo    when the disk boots to Windows - i.e. the boot partition. 
echo    This drive letter will be made bootable using bcdboot and bootsect.
echo    For disks with only one partition, the letter must be %installpath%
echo    For a USB hard drive with one partition, the letter must be %installpath%
echo.
SET Choice=
SET /P Choice=   Please enter the TARGET BOOT DRIVE letter (e.g. %installpath%): 
echo.
IF "%Choice%"=="" goto bootdrive
SET Choice=%Choice:~0,1%:
vol %Choice%>nul 2>nul || (
echo    The partition %Choice% does not exist, please input again.
echo    Press any key to continue...
pause>nul
goto bootdrive
)
echo Testing if the partition is writable >%Choice%\test.tst
if not exist %Choice%\test.tst (
echo    Partition %Choice% is not writable, please input again.
echo    Press any key to continue...
pause>nul
goto bootdrive
)
del %Choice%\test.tst>nul 2>nul
if exist %Choice%\test.tst (
echo    Partition %Choice% is not writable, please input again.
echo    Press any key to continue...
pause>nul
goto bootdrive
)

if "%Choice%"=="%SystemDrive%" (
echo	WARNING: Target drive letter is same as this systems Windows drive letter!
echo	This will overwrite boot files on your %SystemDrive% drive!
SET /P SURE=Do you really want to continue?
if /I NOT "%SURE%"=="Y" goto bootdrive
)


SET bootpath=%Choice%



REM --------------------------------------------------------------------------------------
REM Ask whether the target drive is a USB disk
REM --------------------------------------------------------------------------------------
:usbchoice
SET usbhd=
cls
echo.
echo %title%
echo.                   
echo %updatetime%
echo.
echo    Path of your Wim file: %Wimpath%
echo    The index number: %Wimindex%
echo    Drive letter for OS partition: %installpath%
echo    Drive letter for boot partition: %bootpath%
echo.
echo.   
echo.
SET Choice=
SET /P Choice=    Is %installpath% a USB disk? (Y/N): 
echo.
IF /I NOT "%Choice%"=="Y" IF /I NOT "%Choice%"=="N" goto usbchoice
IF /I "%Choice%"=="Y" (
SET usbhd=YES
) ELSE (
SET usbhd=NO
)


set osletter=

IF %isvista% EQU 1 goto :DOSTART

cls
echo.
echo.
echo.
echo    CHOOSE A WINDOWS DRIVE LETTER FOR THE NEW INSTALLATION
echo    ======================================================
echo.
echo    When the new installation boots, the drive letter of the OS partition in Windows
echo    will be C: by default. 
echo    If you want Windows to have a different drive letter once it has booted,
echo    please input the letter (e.g. D) and press Enter. 
echo.
echo.

REM --------------------------------------------------------------------------------------
REM get which letter the OS partition will occupy after the installation
REM --------------------------------------------------------------------------------------
:startletter
SET osletter=
SET Choice=
SET /P Choice=	Enter drive letter [C-Z] (press Enter for C) : 
IF "%Choice%"=="" goto :DOSTART
SET Choice=%Choice:~0,1%
IF /I %Choice% LEQ z IF /I %Choice% GEQ c (
set osletter=%Choice%
) ELSE (
echo    Input error, please re-input the letter   
goto :startletter
)


:DOSTART

REM --------------------------------------------------------------------------------------
REM Ready to start the installation
REM --------------------------------------------------------------------------------------
cd /d "%TP%"
cls
if "%installpath%"=="%bootpath%" SET DD=%bootpath%
if NOT "%installpath%"=="%bootpath%" SET DD=%bootpath% and %installpath%
echo.
echo %title%
echo.                   
echo %updatetime%
echo.
echo    START THE INSTALLATION TO %DD%
echo    ===================================
echo.
echo    Path of your source wim file: %Wimpath%
echo    The wim file image index number: %Wimindex%
echo    Target Drive letter for OS partition: %installpath%
echo    Target Drive letter for boot partition: %bootpath%
echo    USB disk: %usbhd%
if not "%osletter%"=="" echo    Final Windows drive letter: %osletter%
if "%osletter%"=="" echo    Final Windows drive letter: C:
echo.
echo.
echo    All the information is now collected! 
echo.
echo    Press Enter to start installation to %DD% ...   
pause >nul

IF %isvista% EQU 1 SET osletter=


REM --------------------------------------------------------------------------------------
REM extract the wim file
REM --------------------------------------------------------------------------------------
:startinstall
echo.
echo    Extracting the WIM file, it needs some time, please wait...
imagex /apply %Wimpath% %Wimindex% %installpath%
echo    The Wim file applied O.K.

REM --------------------------------------------------------------------------------------
REM Processing usb boot
REM --------------------------------------------------------------------------------------
cd /d "%TP%"
IF "%usbhd%"=="YES" (
echo Running Set_7_Usb_Boot.cmd
call Set_7_USB_Boot.cmd %installpath%\WINDOWS
)

REM Copy shortcut for sysprepping
IF "%usbhd%"=="YES" (
echo    Copying Sysprep.cmd to Desktop
copy /y "sysprep.cmd" "%installpath%\Users\Public\Desktop\Sysprep for new system.cmd"
if errorlevel 1 pause
) 

REM --------------------------------------------------------------------------------------
REM fix the drive letter of OS partition in the registry of Vista/2008
REM --------------------------------------------------------------------------------------
IF %isvista% EQU 1 (
echo    fixing the drive letter in the registry of Vista/2008
call fixletter.cmd /currentos:%installpath%
)


REM --------------------------------------------------------------------------------------
REM modify the OS partition letter
REM --------------------------------------------------------------------------------------
IF /I '%osletter%' NEQ '' (
echo    Processing the modification of the system drive letter ...
call osletter7.cmd /targetletter:%osletter% /currentos:%installpath%
)


REM --------------------------------------------------------------------------------------
REM Creating bootmgr menu and bootsect
REM --------------------------------------------------------------------------------------
echo    Creating bootmgr menu and bootsect...
bcdboot %installpath%\Windows /s %bootpath% /l %lang% 2>nul
if exist %bootpath%\ntldr (
REM Post-process tag if exist NT 5.x in order to add an ntldr item in the bootmgr menu
md %installpath%\$ntldr
)
bootsect.exe /nt60 %bootpath% /MBR >nul
echo    The boot menu and bootsector has been created (standard MBR installed)! 


REM --------------------------------------------------------------------------------------
REM The autorun script during oobe
REM --------------------------------------------------------------------------------------
if not exist %installpath%\WINDOWS\Setup\Scripts (
md %installpath%\WINDOWS\Setup\Scripts>NUL
)
copy /y SetupComplete.cmd SetupComplete.tmp
if exist %installpath%\WINDOWS\Setup\Scripts\SetupComplete.cmd (
type %installpath%\WINDOWS\Setup\Scripts\SetupComplete.cmd >>SetupComplete.tmp
)
copy /y SetupComplete.tmp %installpath%\WINDOWS\Setup\Scripts\SetupComplete.cmd >NUL

REM --------------------------------------------------------------------------------------
REM copy the $oem$ directory
REM --------------------------------------------------------------------------------------
if exist "%Wimdir%\$OEM$" (
xcopy /? >nul 2>nul
if errorlevel 1 (
echo    xcopy is missing, cannot copy the $oem$ directory.
echo    but the install can continue, press any key... 
echo.
pause >nul
goto end
)
echo    copying %Wimdir%\$OEM$ directory...
xcopy /shey "%Wimdir%\$OEM$\$1" %installpath% >NUL 2>NUL
xcopy /shey "%Wimdir%\$OEM$\$$" %installpath%\WINDOWS >NUL 2>NUL
)

REM --------------------------------------------------------------------------------------
REM end
REM --------------------------------------------------------------------------------------
:end
echo    OK - SUCCESS!
echo    Everything has completed, press any key to exit.
echo    Then boot from the target disk and it should boot to Windows!
echo.
Pause>nul
@echo on
@goto :EOF
::exit
    
:fail
echo    Press any key to exit ...
Pause>nul
@echo on
::exit
